;http://www.elektronik.de.vu/schalt/mikro/buchst.htm
;
;Buchstaben-Zufallsgenerator fr AT90S2313 @ min. 3 MHz
;14-Segment Anzeige an PB (a...g2) und PD0-PD5 (h...m), gem. Anode
;Taster gegen Masse an PD5 (entprellt: 100nF parallel)
;(C) Arne Rossius, 10.2003

;-----------------------------------------------------Definitionen

.nolist
.include "2313def.inc"
.list
.def	temp	= R16
.def	buchst	= R17
.def	anz1	= R18
.def	anz2	= R19
.def	w1	= R20
.def	w2	= R21

;--------------------------------------------------Initialisierung

	ldi	temp,	low(RAMEND)	;Stackpointer setzen
	out	SPL,	r16
	ldi	temp,	0b11111111	;PB0-7 = Ausgang
	out	DDRB,	temp
	ldi	temp,	0b00111111	;g1+g2 an (Strich)
	out	PORTB,	temp
	ldi	temp,	0b00111111	;PD0-5=Ausg., PD6=Eing.
	out	DDRD,	temp
	ldi	temp,	0b01111111	;Alles aus, Pullup an
	out	PORTD,	temp
	ldi	buchst,	0		;kein Buchstabe

;----------------------------------------------------Hauptprogramm

loop:
	sbic	PIND,	6		;Wenn Taster aus:
	rjmp	loop			;Endlosschleife

;--------------------------------------------------Taster gedrckt

	inc	buchst			;nchster Buchstabe
	cpi	buchst,	27		;nach Z: wieder A anzeigen
	brne	codier
	ldi	buchst,	1
codier:
	ldi	anz1,	0b00111111	;Buchstaben codieren
	ldi	anz2,	0b01111111
	cpi	buchst,	1
	brne	b
	ldi	anz1,	0b00001000
	ldi	anz2,	0b01111111
	rjmp	weiter
b:
	cpi	buchst,	2
	brne	c
	ldi	anz1,	0b01110000
	ldi	anz2,	0b01101101
	rjmp	weiter
c:
	cpi	buchst,	3
	brne	d
	ldi	anz1,	0b11000110
	ldi	anz2,	0b01111111
	rjmp	weiter
d:
	cpi	buchst,	4
	brne	e
	ldi	anz1,	0b11110000
	ldi	anz2,	0b01101101
	rjmp	weiter
e:
	cpi	buchst,	5
	brne	f
	ldi	anz1,	0b10000110
	ldi	anz2,	0b01111111
	rjmp	weiter
f:
	cpi	buchst,	6
	brne	g
	ldi	anz1,	0b10001110
	ldi	anz2,	0b01111111
	rjmp	weiter
g:
	cpi	buchst,	7
	brne	h
	ldi	anz1,	0b01000010
	ldi	anz2,	0b01111111
	rjmp	weiter
h:
	cpi	buchst,	8
	brne	i
	ldi	anz1,	0b00001001
	ldi	anz2,	0b01111111
	rjmp	weiter
i:
	cpi	buchst,	9
	brne	j
	ldi	anz1,	0b11111111
	ldi	anz2,	0b01101101
	rjmp	weiter
j:
	cpi	buchst,	10
	brne	k
	ldi	anz1,	0b11100001
	ldi	anz2,	0b01111111
	rjmp	weiter
k:
	cpi	buchst,	11
	brne	l
	ldi	anz1,	0b10001111
	ldi	anz2,	0b01011011
	rjmp	weiter
l:
	cpi	buchst,	12
	brne	m
	ldi	anz1,	0b11000111
	ldi	anz2,	0b01111111
	rjmp	weiter
m:
	cpi	buchst,	13
	brne	n
	ldi	anz1,	0b11001001
	ldi	anz2,	0b01111010
	rjmp	weiter
n:
	cpi	buchst,	14
	brne	o
	ldi	anz1,	0b11001001
	ldi	anz2,	0b01011110
	rjmp	weiter
o:
	cpi	buchst,	15
	brne	p
	ldi	anz1,	0b11000000
	ldi	anz2,	0b01111111
	rjmp	weiter
p:
	cpi	buchst,	16
	brne	q
	ldi	anz1,	0b00001100
	ldi	anz2,	0b01111111
	rjmp	weiter
q:
	cpi	buchst,	17
	brne	r
	ldi	anz1,	0b11000000
	ldi	anz2,	0b01011111
	rjmp	weiter
r:
	cpi	buchst,	18
	brne	s
	ldi	anz1,	0b00001100
	ldi	anz2,	0b01011111
	rjmp	weiter
s:
	cpi	buchst,	19
	brne	t
	ldi	anz1,	0b00010010
	ldi	anz2,	0b01111111
	rjmp	weiter
t:
	cpi	buchst,	20
	brne	u
	ldi	anz1,	0b11111110
	ldi	anz2,	0b01101101
	rjmp	weiter
u:
	cpi	buchst,	21
	brne	v
	ldi	anz1,	0b11000001
	ldi	anz2,	0b01111111
	rjmp	weiter
v:
	cpi	buchst,	22
	brne	w
	ldi	anz1,	0b11001111
	ldi	anz2,	0b01110011
	rjmp	weiter
w:
	cpi	buchst,	23
	brne	x
	ldi	anz1,	0b11001001
	ldi	anz2,	0b01010111
	rjmp	weiter
x:
	cpi	buchst,	24
	brne	y
	ldi	anz1,	0b11111111
	ldi	anz2,	0b01010010
	rjmp	weiter
y:
	cpi	buchst,	25
	brne	z
	ldi	anz1,	0b00011101
	ldi	anz2,	0b01101111
	rjmp	weiter
z:
	cpi	buchst,	26
	brne	weiter
	ldi	anz1,	0b11110110
	ldi	anz2,	0b01110011
	rjmp	weiter
weiter:
	clr	w1			;kurz warten
warte:
	inc	w1
	brne	warte
	out	PORTB,	anz1		;Buchstaben anzeigen
	out	PORTD,	anz2
	rjmp	loop			;zurck zum Hauptprogramm
